package com.corejdo.examples.chapter3;

import javax.jdo.PersistenceManager;
import javax.jdo.PersistenceManagerFactory;
import javax.jdo.Transaction;

import com.corejdo.examples.model.Author;
import com.corejdo.examples.util.PersistenceManagerFactoryHelper;

/**
 * @author mccammon
 * @see com.corejdo.examples.util.PersistenceManagerFactoryHelper
 * @see com.corejdo.examples.model.Author
 *
 */
public final class CreateWithExceptionsExample {

  /**
   * <p>Uywana do uruchomienia przykadu. Nie wymaga parametrw podczas uruchamiania z wiersza polece.</p>
   * 
   * @param args command line arguments
   */
  public static void main(String[] args) {

    PersistenceManagerFactory pmf =
      PersistenceManagerFactoryHelper.getPersistenceManagerFactory();

    PersistenceManager pm = null;

    try {

      pm = pmf.getPersistenceManager();

      Transaction tx = pm.currentTransaction();

      tx.begin();

      Author author = new Author("Keiron McCammon");

      pm.makePersistent(author);

      tx.commit();

      pm.close();
    }

    finally {

      if (pm != null && !pm.isClosed()) {

        if (pm.currentTransaction().isActive()) {

          pm.currentTransaction().rollback();
        }

        pm.close();
      }
    }
  }

  private CreateWithExceptionsExample() {}
}
